C       OPTIONS(SAVE,DREAL,OPTIMISE)
C       THESE ARE OPTIONS FOR THE FTN77 COMPILER UNIVERSITY OF SALFORD
C       REMOVE THEM USING C IN THE FIRST COLUMN (COMMENT) IF USING
C       OTHER COMPILER
        PROGRAM KONVOL7
C               ~~~~~~~
C       VERSION: JULY 19, 1992
C       PROGRAMM FOR CALCULATING OF THE CONVOLUTION WITH CHOSEN FUNCTION
C       BASED ON NUMERICAL INTEGRATION
C       FOR CHOSEN FILTER FUNCTION JUST WRITE YOUR OWN 'FUNCTION FILTER(X)'
C       AND RENAME THE ORIGINAL ONE
C       YOU ARE SUPPOSED TO CHOSE FILTER(0)=1 NOT TO CHANGE AN INTEGRAL
C       OF THE ORIGINAL FUNCTION
C       IF ANY DOUBTS JUST CONTACT: JAN BUDAJ
C                                   ASTRONOMICAL INSTITUTE
C                                   SLOVAC ACADEMY OF SCIENCES
C                                   059 60 TATRANSKA LOMNICA
C                                   CZECHOSLOVAKIA
C       RYCHLEJSIA PRESNA VERZIA PRE UZKE FILTRE
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION X1(20000),F1(20000)
        CHARACTER*12 IN,INN
        COMMON /POLIA/ X(2000),F(2000)
        COMMON /ALF/ IVOL,A,DLL,UKOEF
        OPEN(5,FILE='CON')
        WRITE(5,*)
        WRITE(5,*)'-------------------------------------------'
        WRITE(5,*)'                   PROGRAMM FOR CONVOLUTION'
        WRITE(5,*)'-------------------------------------------'
        WRITE(5,*)
        WRITE(5,*)' NOTE. TO REACH REL. ERROR 1/1000 FOR "SOLID"'
        WRITE(5,*)'       FUNCTION WE RECOMMEND FOR GAUSS.FILTER:'
        WRITE(5,*)'         FILTER WIDTH/4=HALFWIDTH=1.7*STEP'
        WRITE(5,*)'       FOR ROTATION: STEP=HALFWIDTH/20'
        WRITE(5,*)'       BUT ALWAYS: STEP<=CHARACTER. DISTANCE'
        WRITE(5,*)'         OF THE CHANGES IN YOUR FUNCTION OR FILTER'
        WRITE(5,*)'       [YU] -YOUR UNIT OF THE X AXIS'
        WRITE(5,*)
        WRITE(5,'(A17,$)')' INPUT FILE   => '
        READ(5,'(A12)')IN
        WRITE(5,'(A17,$)')' OUTPUT FILE  => '
        READ(5,'(A12)')INN
5       OPEN(2,FILE=IN,STATUS='OLD')
        OPEN(3,FILE=INN,STATUS='NEW')
        WRITE(5,*)
        WRITE(5,*)' GAUSS. FILTER     -1-'
        WRITE(5,*)' ROTATION          -2-'
        WRITE(5,*)' OWN FILTER        -3-'
        WRITE(5,'(A,$)')'  FINISH            -4-      => '
        READ(5,*)IVOL
        WRITE(5,*)
        IF (IVOL.EQ.4)GOTO 40
        IF (IVOL.EQ.1)THEN
          WRITE(5,'(A,$)')'  HALFWIDTH OF THE FILTER [YU]      => '
          READ(5,*)B
          A=2.D0*DSQRT(-DLOG(0.5D0))/B
          WRITE(5,'(A,$)')'  WIDTH OF THE FILTER [YU]          => '
          READ(5,*)CUTOFF
          CUTOFF=CUTOFF*0.5D0
        ENDIF
        IF (IVOL.EQ.2)THEN
        WRITE(5,'(A,$)')'  V*SIN I [KM/S], TEMPER. [K], LAMBDA [A]  => '
          READ(5,*)VSIN,TEP,FREQ
        WRITE(5,'(A,$)')'  WHAT PART OF 1NM IS 1YU                  => '
          READ(5,*)UMERA
          CALL LIMBDARK(TEP/10000.D0,FREQ/10000.D0,UKOEF)
          FREQ=FREQ/10.D0
          DLL=VSIN*FREQ/299792.D0/UMERA
          CUTOFF=DLL
          WRITE(5,*)
          WRITE(5,'(20X,A,F6.3)')' COEF. OF THE DARKNESS',UKOEF
          WRITE(5,'(20X,A,F8.3)')' ROTATIONAL HALFWIDTH [YU]',CUTOFF
        ENDIF
        WRITE(5,*)
        WRITE(5,'(A,$)')'  STEP [YU]                  => '
        READ(5,*)SPACE
        NSPACE=DINT(2.D0*CUTOFF/SPACE)+1
        SPACE=2.D0*CUTOFF/DBLE(NSPACE)
        WRITE(5,'(/20X,A,I5,E14.6)')' NUMBER OF STEPS, MODIF.STEP'
     P  ,NSPACE,SPACE
        WRITE(5,'(/A)')'  TOO MUCH RAREFIED DATA <20000  -1- '
        WRITE(5,'(A)')'  TOO LITTLE RAREFIED DATA  <2000  -2- '
        WRITE(5,'(A,$)')'  TOO MUCH CLUSTERED DATA  <20000  -3-  => '
        READ(5,*)IVOL1
        I=1
10      READ(2,*,END=20)X1(I),F1(I)
        I=I+1
        GOTO 10
20      NDAT1=I-1
        IF(IVOL1.EQ.1.OR.IVOL1.EQ.3)THEN
          WRITE(5,'(/A,$)')'  MAX. NUMBER OF POINTS IN WIDTH OF FILTER
     P<2000  => '
          READ(5,*)NDAT
          WRITE(5,'(A,$)')'  I CACULATE CONVOL. FOR EACH N-TH POINT
     P[1-FOR EACH] => '
          READ(5,*)NSTEP
          IF (NDAT.GE.NDAT1)THEN
            NDAT=NDAT1
            IVOL1=2
          ENDIF
        ELSE
          NDAT=NDAT1
          NSTEP=1
        ENDIF
        IF(IVOL1.EQ.2)THEN
            DO 22 J=1,NDAT1
              X(J)=X1(J)
              F(J)=F1(J)
22          CONTINUE
        ENDIF
        WRITE(5,*)'    X         Y'
        DO 30 I=1,NDAT1,NSTEP
          IF(IVOL1.EQ.2)GOTO 27
          DO 25 J=1,NDAT
            K=I
            IF(I-NDAT/2-1.LT.0)K=NDAT/2+1
            IF(I-NDAT/2-1+NDAT.GT.NDAT1)K=NDAT1+NDAT/2+1-NDAT
            X(J)=X1(K-NDAT/2-1+J)
            F(J)=F1(K-NDAT/2-1+J)
25        CONTINUE
27        IF (IVOL1.EQ.3)THEN
            IF(X1(I)-X(1).LT.CUTOFF.OR.X(NDAT)-X1(I).LT.CUTOFF)THEN
              AK=AKONV(X1(I),SPACE,NSPACE,CUTOFF,NDAT)
            ELSE
              AK=AKONV1(X1(I),NDAT)
            ENDIF
          ELSE
            AK=AKONV(X1(I),SPACE,NSPACE,CUTOFF,NDAT)
          ENDIF
          WRITE(5,'(2E14.6)')X1(I),AK
          WRITE(3,'(2E14.6)')X1(I),AK
30      CONTINUE
        CLOSE (2)
        CLOSE (3)
        GOTO 5
40      CONTINUE
        CLOSE(5)
        STOP
        END
C-----------------------------------------------------------------------
        FUNCTION AKONV(XX,SPACE,NSPACE,CUTOFF,NDAT)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       X(I)  - POLE X-OVYCH HODNOT, X(I+1) > X(I)
C       F(I)  - POLE Y-OVYCH HODNOT FILTROVANEJ FUNKCIE V BODOCH X(I)
C       XX    - X-OVA SURADNICA BODU KDE TA ZAUJIMA KONVOLUCIA
C       SPACE - INTEGRACNY KROK
C       NSPACE-
C       CUTOFF-
C       NDAT  - POCET DAT
C       NDIM  - DIMENZACNY PARAMETER
C       IVOL  - VOLBA DRUHU KONVOLUCIE
C       A     - 1/POLOSIRKA FILTRU
C       VSIN  - V*SIN I [KM/S]
C       UKOEF - KOEF. STEMNENIA
C       FREQ  - LAMBDA V [NM]
C       AKONV - HODNOTA KONVOLUCIE (VYFITROVANA HODNOTA FUNKCIE) V XX
C       FILTER- FILTRUJUCA FUNKCIA (JE VYHODNE ABY PRE X=0 FILTER=1
C               => FILTROVANIM SA NEMENI INTEGRAL FILTROVANEJ FUNKCIE)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        COMMON /POLIA/ X(2000),F(2000)
        COMMON /ALF/ IVOL,A,DLL,UKOEF
        SUMA=0.D0
        XI1=XX-CUTOFF
        CALL INTEP(XI1,YI1,NDAT,IER)
        F1=FILTER(XI1-XX)
        DO 100 I=1,NSPACE
          XI2=XI1+SPACE/2.D0
          XI3=XI1+SPACE
          F2=FILTER(XI2-XX)
          F3=FILTER(XI3-XX)
          CALL INTEP(XI2,YI2,NDAT,IER)
          CALL INTEP(XI3,YI3,NDAT,IER)
          SUMA=(F1*YI1+4.D0*F2*YI2+F3*YI3)+SUMA
          YI1=YI3
          XI1=XI3
          F1=F3
100     CONTINUE
        AKONV=SPACE*SUMA/6.D0
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION AKONV1(XX,NDAT)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       X(I)  - POLE X-OVYCH HODNOT, X(I+1) > X(I)
C       F(I)  - POLE Y-OVYCH HODNOT FILTROVANEJ FUNKCIE V BODOCH X(I)
C       XX    - X-OVA SURADNICA BODU KDE TA ZAUJIMA KONVOLUCIA
C       NDAT  - POCET DAT
C       IVOL  - VOLBA DRUHU KONVOLUCIE
C       A     - 1/POLOSIRKA FILTRU
C       DLL   - V*SIN I [KM/S]/C*LAMBDA
C       UKOEF - KOEF. STEMNENIA
C       AKONV1- HODNOTA KONVOLUCIE (VYFITROVANA HODNOTA FUNKCIE) V XX
C       FILTER- FILTRUJUCA FUNKCIA (JE VYHODNE ABY PRE X=0 FILTER=1
C               => FILTROVANIM SA NEMENI INTEGRAL FILTROVANEJ FUNKCIE)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        COMMON /POLIA/ X(2000),F(2000)
        COMMON /ALF/ IVOL,A,DLL,UKOEF
        SUMA=0.D0
        DO 100 I=1,NDAT-1
          F1=F(I)
          F2=F(I+1)
          SUMA=(F2*FILTER(X(I+1)-XX)+F1*FILTER(X(I)-XX))*0.5D0
     P    *(X(I+1)-X(I))+SUMA
100     CONTINUE
        AKONV1=SUMA
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION FILTER(X)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        COMMON /ALF/ IVOL,A,DLL,UKOEF
          IF (IVOL.EQ.1)THEN
            FILTER=GAUS(X,A)
            RETURN
          ENDIF
          IF (IVOL.EQ.2)THEN
            FILTER=ROT(X,DLL,UKOEF)
            RETURN
          ENDIF
          IF (IVOL.EQ.3)THEN
            WRITE(5,*)'    YOUR OWN FUNCTION FILTER(X) NOT PRESENT'
            WRITE(5,*)'    OR YOU HAVE TO RENAME THE OLD ONE'
            STOP
          ENDIF
        END
C-----------------------------------------------------------------------
        FUNCTION GAUS(X,A)
C               1/A JE POLOSIRKA
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        AL=A*A*X*X
        IF(AL.GT.16.D0)THEN
          GAUS=0.D0
          RETURN
        ELSE
          GAUS=A/DSQRT(3.1415925D0)*DEXP(-AL)
          RETURN
        ENDIF
        END
C-----------------------------------------------------------------------
        FUNCTION ROT(DL,DLL,UKOEF)
C               DL   - ARGUMENT ROTACNEJ FUNKCIE V [TJ]
C               DLL  - ROTACNA POLOSIRKA V [TJ]
C               UKOEF- KOEF.STEMNENIA
C       VYSTUP       - ROT. PROFIL V [TJ]
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        IF(DL*DL.GT.DLL*DLL)THEN
          ROT=0.D0
          RETURN
        ENDIF
        ROT=(2.D0*(1.D0-UKOEF)*DSQRT(1.D0-DL*DL/DLL/DLL)+0.5D0*3.1415D0
     P  *UKOEF*(1.D0-DL*DL/DLL/DLL))/(3.1415D0*DLL*(1.D0-UKOEF/3.D0))
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE LIMBDARK(TEMP,WAVLEN,XX)
C THIS SUBROUTINE WAS WRITTEN BY BARONE ET AL.
C
C TEMP   = TEMPERATURE, IN UNITS OF 10000 K
C WAVLEN = WAVELENGTH, IN UNITS OF ANGSTROM * 10000
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION ARG(2),NENT(2),ENT(35),TABLE(294)
     P  ,TABLE1(105),TABLE2(105),TABLE3(84)
C
C       THE TABLE IS FORMATTED AS FOLLOWS:
C
C --------------------------------------
C            T1   T2   T3   T4   T5  ...
C --------------------------------------
C    WL1      1    2    3    4    5
C    WL2      6    7    8    9   10
C    WL3     11   12   13   14   15
C    ...
C    ...
C --------------------------------------
C
C
        DATA TABLE1
     1  /0.06,0.18,0.52,0.52,0.28,1.00,1.00,1.00,1.00,1.00,
     2  1.00,1.00,0.98,0.93,0.87,0.79,0.73,0.68,0.65,0.58,0.51,
     3  0.99,0.99,1.00,0.97,0.90,0.82,0.78,0.74,0.70,0.64,
     4  0.60,0.59,0.57,0.56,0.53,0.49,0.46,0.44,0.43,0.40,0.38,
     5  0.87,0.87,0.95,0.84,0.76,0.68,0.63,0.58,0.53,0.47,
     6  0.42,0.40,0.39,0.40,0.38,0.36,0.35,0.34,0.34,0.33,0.32,
     7  0.97,0.97,0.94,0.87,0.83,0.80,0.78,0.74,0.72,0.69,
     8  0.63,0.59,0.55,0.52,0.49,0.45,0.43,0.41,0.39,0.37,0.34,
     9  1.00,0.99,0.85,0.78,0.75,0.72,0.71,0.68,0.66,0.62,
     1  0.57,0.54,0.51,0.48,0.47,0.42,0.40,0.38,0.36,0.34,0.32/
       DATA TABLE2
     1 /0.97,0.90,0.77,0.71,0.68,0.66,0.65,0.63,0.60,0.56,
     3 0.52,0.49,0.47,0.44,0.41,0.38,0.35,0.34,0.32,0.31,0.29,
     4 0.88,0.83,0.71,0.65,0.62,0.60,0.59,0.57,0.55,0.51,
     5 0.47,0.45,0.43,0.40,0.38,0.34,0.32,0.31,0.30,0.28,0.27,
     6 0.81,0.76,0.65,0.60,0.57,0.55,0.54,0.52,0.50,0.46,
     7 0.43,0.41,0.39,0.37,0.35,0.31,0.30,0.28,0.27,0.26,0.25,
     8 0.69,0.65,0.56,0.52,0.49,0.47,0.46,0.44,0.42,0.38,
     9 0.36,0.34,0.33,0.31,0.29,0.27,0.25,0.24,0.23,0.22,0.22,
     1 0.61,0.58,0.50,0.49,0.43,0.41,0.40,0.38,0.36,0.33,
     2 0.30,0.29,0.28,0.26,0.25,0.23,0.21,0.20,0.20,0.20,0.20/
       DATA TABLE3
     3 /0.52,0.49,0.43,0.40,0.38,0.37,0.37,0.36,0.34,0.31,
     4 0.29,0.28,0.26,0.25,0.24,0.21,0.20,0.19,0.18,0.18,0.18,
     5 0.48,0.46,0.40,0.36,0.35,0.33,0.32,0.31,0.28,0.26,
     6 0.24,0.23,0.22,0.21,0.20,0.18,0.17,0.16,0.15,0.15,0.16,
     7 0.40,0.38,0.33,0.31,0.29,0.28,0.26,0.25,0.23,0.21,
     8 0.20,0.19,0.18,0.17,0.16,0.14,0.13,0.13,0.12,0.12,0.13,
     9 0.33,0.31,0.27,0.25,0.23,0.22,0.20,0.19,0.17,0.16,
     1 0.14,0.13,0.13,0.12,0.11,0.10,0.09,0.09,0.09,0.10,0.10/
        DATA NENT/21,14/
        DATA ENT/4000.,4500.,5000.,5500.,6000.,6500.,7000.,7500.,
     1 8000.,8500.,9000.,9500.,10000.,11000.,12000.,14000.,
     2 16000.,18000.,20000.,25000.,30000.,
     3 2000.,3000.,3600.,4000.,4500.,5000.,5500.,6000.,7000.,
     4 8000.,10000.,12000.,16000.,22000./
        DO 10 I=1,294
          IF(I.LE.105)TABLE(I)=TABLE1(I)
          IF(I.GE.106.AND.I.LE.210)TABLE(I)=TABLE2(I-105)
          IF(I.GE.211)TABLE(I)=TABLE3(I-210)
10      CONTINUE
        NARG=2
        ARG(1)=TEMP*10000.
        ARG(2)=WAVLEN*10000.
        XX=FINT(NARG,ARG,NENT,ENT,TABLE)
        RETURN
        END
C-----------------------------------------------------------------------
       FUNCTION FINT(NARG,ARG,NENT,ENT,TABLE)
C THIS SUBROUTINE WAS WRITTEN BY BARONE ET AL.
C**     FUNCTION PER INTERPOL. LINEARE IN UNA TABELLA MULTIDIMENSIONALE
C
C       CHIAMATA:       VALINT= FINT(NARG,ARG,NENT,ENT,TABLE)
C
C       ARGOMENTI:      NARG= DIMENSIONE DEL VETTORE ARG (<6)
C                       ARG= COORDINATE DEL PUNTO IN CUI INTERPOLARE
C                       NENT= LISTA DEI NUMERI DI ENTRIES PER OGNI ARG.
C                       ENT= ENTRIES DELLA TABELLA
C                       TABLE= VALORI DELLA TABELLA
C
C      REAL*8 FUNCTION FINT(NARG,ARG,NENT,ENT,TABLE)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION ARG(2),NENT(2),ENT(35),TABLE(294)
C      DIMENSION ARG(5),NENT(5),ENT(10),TABLE(10)   PRE F77 VER3.34
      DIMENSION D(5),NCOMB(5),IENT(5)
      KD=1
      M=1
      JA=1
      DO 80 I=1,NARG
      NCOMB(I)=1
      JB=JA-1+NENT(I)
      DO 20 J=JA,JB
      IF (ARG(I).LE.ENT(J)) GO TO 40
20    CONTINUE
      J=JB
40    IF (J.NE.JA) GO TO 60
      J=J+1
60    JR=J-1
      D(I)=(ENT(J)-ARG(I))/(ENT(J)-ENT(JR))
      IENT(I)=J-JA
      KD=KD+IENT(I)*M
      M=M*NENT(I)
80    JA=JB+1
      FINT=0.
100   FAC=1.
      IADR=KD
      IFADR=1
      DO 140 I=1,NARG
      IF (NCOMB(I).EQ.0) GO TO 120
      FAC=FAC*(1.-D(I))
      GO TO 140
120   FAC=FAC*D(I)
      IADR=IADR-IFADR
140   IFADR=IFADR*NENT(I)
      FINT=FINT+FAC*TABLE(IADR)
      IL=NARG
160   IF (NCOMB(IL).EQ.0) GO TO 200
      NCOMB(IL)=0
      IF (IL.EQ.NARG) GO TO 100
      IL=IL+1
      DO 180  K=IL,NARG
180   NCOMB(K)=1
      GO TO 100
200   IL=IL-1
      IF(IL.NE.0) GO TO 160
      RETURN
      END
C-----------------------------------------------------------------------
C       SUBROUTINE   I N T E P  : SPLINE INTERPOLATION SCHEME BASED
C                                 ON HERMITE POLYNOMIALS
C        INPUT : XP  - THE CHOSEN ARGUMENT VALUE
C                X   - THE VECTOR OF INDEPENDENT VALUES
C                F   - THE VECTOR OF FUNCTION OR DEPENDENT VALUES
C                N   - THE NUMBER OF POINTS IN THE (X,F) VECTORS
C       OUTPUT : P   - THE RESULTANT INTERPOLATED VALUE
C                IER - THE RESULTANT ERROR PARAMETER
        SUBROUTINE INTEP(XP,P,N,IER)
C       SUBROUTINE INTEP(XP,P,X,F,N,IER)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        REAL LP1,LP2,L1,L2
C       DIMENSION F(NDIM),X(NDIM)
C       DIMENSION F(N),X(N)
        COMMON /POLIA/X(2000),F(2000)
        IER=1
        IO=1
        IUP=0
        IF(X(2).LT.X(1)) IUP=1
        N1=N-1
        IF((XP.GE.X(N).AND.IUP.EQ.0).OR.(XP.LE.X(N).AND.IUP.EQ.1)) THEN
         P=F(N)
         IER=2
         RETURN
        ELSE IF((XP.LE.X(1).AND.IUP.EQ.0).OR.
     *   (XP.GE.X(1).AND.IUP.EQ.1)) THEN
         P=F(1)
         IER=2
         RETURN
        END IF
        DO 1 I=IO,N
         IF(XP.LT.X(I).AND.IUP.EQ.0) GOTO 2
         IF(XP.GT.X(I).AND.IUP.EQ.1) GOTO 2
1       CONTINUE
        P=F(N)
        IER=2
        RETURN
2       I=I-1
        IF(I.EQ.IO-1) GOTO 4
        IO=I+1
        LP1=1./(X(I)-X(I+1))
        LP2=1./(X(I+1)-X(I))
        IF(I.EQ.1) FP1=(F(2)-F(1))/(X(2)-X(1))
        IF(I.EQ.1) GOTO 3
        FP1=(F(I+1)-F(I-1))/(X(I+1)-X(I-1))
3       IF(I.GE.N1) FP2=(F(N)-F(N-1))/(X(N)-X(N-1))
        IF(I.GE.N1) GOTO 4
        FP2=(F(I+2)-F(I))/(X(I+2)-X(I))
4       XPI1=XP-X(I+1)
        XPI=XP-X(I)
        L1=XPI1*LP1
        L2=XPI*LP2
        P=F(I)*(1.-2.*LP1*XPI)*L1*L1+F(I+1)*(1.-2.*LP2*XPI1)
     *  *L2*L2+FP2*XPI1*L2*L2+FP1*XPI*L1*L1
        RETURN
        END
